<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>Mu - apps/mandelbrot.mu</title>
<meta name="Generator" content="Vim/8.2">
<meta name="plugin-version" content="vim8.1_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,pre_wrap,no_foldcolumn,expand_tabs,line_ids,prevent_copy=,use_input_for_pc=fallback">
<meta name="colorscheme" content="minimal-light">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #000000; background-color: #ffffd7; }
body { font-size:12pt; font-family: monospace; color: #000000; background-color: #ffffd7; }
a { color:inherit; }
* { font-size:12pt; font-size: 1em; }
.PreProc { color: #c000c0; }
.muRegEdx { color: #af5f00; }
.Special { color: #ff6060; }
.LineNr { }
.muRegEsi { color: #005faf; }
.muRegEbx { color: #5f00ff; }
.Constant { color: #008787; }
.muRegEdi { color: #00af00; }
.muRegEcx { color: #870000; }
.Delimiter { color: #c000c0; }
.muFunction { color: #af5f00; text-decoration: underline; }
.muComment { color: #005faf; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<a href='https://github.com/akkartik/mu/blob/main/apps/mandelbrot.mu'>https://github.com/akkartik/mu/blob/main/apps/mandelbrot.mu</a>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span><span class="muComment"># Mandelbrot set</span>
<span id="L2" class="LineNr">  2 </span><span class="muComment">#</span>
<span id="L3" class="LineNr">  3 </span><span class="muComment"># Install:</span>
<span id="L4" class="LineNr">  4 </span><span class="muComment">#   $ git clone <a href="https://github.com/akkartik/mu">https://github.com/akkartik/mu</a></span>
<span id="L5" class="LineNr">  5 </span><span class="muComment">#   $ cd mu</span>
<span id="L6" class="LineNr">  6 </span><span class="muComment"># Build on Linux:</span>
<span id="L7" class="LineNr">  7 </span><span class="muComment">#   $ ./translate apps/mandelbrot.mu</span>
<span id="L8" class="LineNr">  8 </span><span class="muComment"># Build on other platforms (slow):</span>
<span id="L9" class="LineNr">  9 </span><span class="muComment">#   $ ./translate_emulated apps/mandelbrot.mu</span>
<span id="L10" class="LineNr"> 10 </span><span class="muComment"># Run:</span>
<span id="L11" class="LineNr"> 11 </span><span class="muComment">#   $ qemu-system-i386 code.img</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L13'>main</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>), keyboard: (addr keyboard), data-disk: (addr disk) <span class="Delimiter">{</span>
<span id="L14" class="LineNr"> 14 </span>  <span class="muComment"># Initially the viewport is centered at 0, 0 in the scene.</span>
<span id="L15" class="LineNr"> 15 </span>  <span class="PreProc">var</span> zero: float
<span id="L16" class="LineNr"> 16 </span>  <span class="PreProc">var</span> scene-cx/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L17" class="LineNr"> 17 </span>  <span class="PreProc">var</span> scene-cy/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L18" class="LineNr"> 18 </span>  <span class="muComment"># Initially the viewport shows a section of the scene 4 units wide.</span>
<span id="L19" class="LineNr"> 19 </span>  <span class="muComment"># scene-width-scale = 0.5</span>
<span id="L20" class="LineNr"> 20 </span>  <span class="PreProc">var</span> scene-width-scale: float
<span id="L21" class="LineNr"> 21 </span>  <span class="PreProc">var</span> dest/eax: (addr float) <span class="Special">&lt;-</span> address scene-width-scale
<span id="L22" class="LineNr"> 22 </span>  <a href='../408float.mu.html#L3'>fill-in-rational</a> dest, <span class="Constant">1</span>, <span class="Constant">2</span>
<span id="L23" class="LineNr"> 23 </span>  <span class="muComment"># scene-width = 4</span>
<span id="L24" class="LineNr"> 24 </span>  <span class="PreProc">var</span> four: float
<span id="L25" class="LineNr"> 25 </span>  <span class="PreProc">var</span> dest/eax: (addr float) <span class="Special">&lt;-</span> address four
<span id="L26" class="LineNr"> 26 </span>  <a href='../408float.mu.html#L3'>fill-in-rational</a> dest, <span class="Constant">4</span>, <span class="Constant">1</span>
<span id="L27" class="LineNr"> 27 </span>  <span class="PreProc">var</span> scene-width/<span class="Constant">xmm3</span>: float <span class="Special">&lt;-</span> copy four
<span id="L28" class="LineNr"> 28 </span>  <span class="Delimiter">{</span>
<span id="L29" class="LineNr"> 29 </span>    <a href='mandelbrot.mu.html#L41'>mandelbrot</a> <a href='../500fake-screen.mu.html#L16'>screen</a> scene-cx, scene-cy, scene-width
<span id="L30" class="LineNr"> 30 </span>    <span class="muComment"># move the center some % of the current screen-width</span>
<span id="L31" class="LineNr"> 31 </span>    <span class="PreProc">var</span> adj/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> <a href='../408float.mu.html#L18'>rational</a> <span class="Constant">2</span>, <span class="Constant">0x1c</span>/<span class="Constant">28</span>
<span id="L32" class="LineNr"> 32 </span>    adj <span class="Special">&lt;-</span> multiply scene-width
<span id="L33" class="LineNr"> 33 </span>    scene-cx <span class="Special">&lt;-</span> subtract adj
<span id="L34" class="LineNr"> 34 </span>    scene-cy <span class="Special">&lt;-</span> add adj
<span id="L35" class="LineNr"> 35 </span>    <span class="muComment"># slowly shrink the scene width to zoom in</span>
<span id="L36" class="LineNr"> 36 </span>    scene-width <span class="Special">&lt;-</span> multiply scene-width-scale
<span id="L37" class="LineNr"> 37 </span>    <span class="PreProc">loop</span>
<span id="L38" class="LineNr"> 38 </span>  <span class="Delimiter">}</span>
<span id="L39" class="LineNr"> 39 </span><span class="Delimiter">}</span>
<span id="L40" class="LineNr"> 40 </span>
<span id="L41" class="LineNr"> 41 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L41'>mandelbrot</a></span> <a href='../500fake-screen.mu.html#L16'>screen</a>: (addr <a href='../500fake-screen.mu.html#L16'>screen</a>), scene-cx: float, scene-cy: float, scene-width: float <span class="Delimiter">{</span>
<span id="L42" class="LineNr"> 42 </span>  <span class="PreProc">var</span> a/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L43" class="LineNr"> 43 </span>  <span class="PreProc">var</span> b/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L44" class="LineNr"> 44 </span>  a, b <span class="Special">&lt;-</span> <a href='../500fake-screen.mu.html#L75'>screen-size</a> <a href='../500fake-screen.mu.html#L16'>screen</a>
<span id="L45" class="LineNr"> 45 </span>  <span class="PreProc">var</span> width/<span class="muRegEsi">esi</span>: int <span class="Special">&lt;-</span> copy a
<span id="L46" class="LineNr"> 46 </span>  width <span class="Special">&lt;-</span> shift-left <span class="Constant">3</span>/log2-font-width
<span id="L47" class="LineNr"> 47 </span>  <span class="PreProc">var</span> height/<span class="muRegEdi">edi</span>: int <span class="Special">&lt;-</span> copy b
<span id="L48" class="LineNr"> 48 </span>  height <span class="Special">&lt;-</span> shift-left <span class="Constant">4</span>/log2-font-height
<span id="L49" class="LineNr"> 49 </span>  <span class="PreProc">var</span> y/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L50" class="LineNr"> 50 </span>  <span class="Delimiter">{</span>
<span id="L51" class="LineNr"> 51 </span>    compare y, height
<span id="L52" class="LineNr"> 52 </span>    <span class="PreProc">break-if-&gt;=</span>
<span id="L53" class="LineNr"> 53 </span>    <span class="PreProc">var</span> imaginary/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L157'>viewport-to-imaginary</a> y, width, height, scene-cy, scene-width
<span id="L54" class="LineNr"> 54 </span>    <span class="PreProc">var</span> x/<span class="muRegEbx">ebx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L55" class="LineNr"> 55 </span>    <span class="Delimiter">{</span>
<span id="L56" class="LineNr"> 56 </span>      compare x, width
<span id="L57" class="LineNr"> 57 </span>      <span class="PreProc">break-if-&gt;=</span>
<span id="L58" class="LineNr"> 58 </span>      <span class="PreProc">var</span> real/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L138'>viewport-to-real</a> x, width, scene-cx, scene-width
<span id="L59" class="LineNr"> 59 </span>      <span class="PreProc">var</span> iterations/eax: int <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L73'>mandelbrot-iterations-for-point</a> real, imaginary, <span class="Constant">0x400</span>/max
<span id="L60" class="LineNr"> 60 </span>      iterations <span class="Special">&lt;-</span> shift-right <span class="Constant">3</span>
<span id="L61" class="LineNr"> 61 </span>      <span class="PreProc">var</span> color/<span class="muRegEdx">edx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L62" class="LineNr"> 62 </span>      iterations, color <span class="Special">&lt;-</span> <a href='../314divide.subx.html#L3'>integer-divide</a> iterations, <span class="Constant">0x18</span>/<span class="Constant">24</span>/size-of-cycle-0
<span id="L63" class="LineNr"> 63 </span>      color <span class="Special">&lt;-</span> add <span class="Constant">0x20</span>/cycle-0
<span id="L64" class="LineNr"> 64 </span>      <a href='../500fake-screen.mu.html#L580'>pixel</a> <a href='../500fake-screen.mu.html#L16'>screen</a>, x, y, color
<span id="L65" class="LineNr"> 65 </span>      x <span class="Special">&lt;-</span> increment
<span id="L66" class="LineNr"> 66 </span>      <span class="PreProc">loop</span>
<span id="L67" class="LineNr"> 67 </span>    <span class="Delimiter">}</span>
<span id="L68" class="LineNr"> 68 </span>    y <span class="Special">&lt;-</span> increment
<span id="L69" class="LineNr"> 69 </span>    <span class="PreProc">loop</span>
<span id="L70" class="LineNr"> 70 </span>  <span class="Delimiter">}</span>
<span id="L71" class="LineNr"> 71 </span><span class="Delimiter">}</span>
<span id="L72" class="LineNr"> 72 </span>
<span id="L73" class="LineNr"> 73 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L73'>mandelbrot-iterations-for-point</a></span> real: float, imaginary: float, max: int<span class="PreProc"> -&gt; </span>_/eax: int <span class="Delimiter">{</span>
<span id="L74" class="LineNr"> 74 </span>  <span class="PreProc">var</span> zero: float
<span id="L75" class="LineNr"> 75 </span>  <span class="PreProc">var</span> x/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L76" class="LineNr"> 76 </span>  <span class="PreProc">var</span> y/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy zero
<span id="L77" class="LineNr"> 77 </span>  <span class="PreProc">var</span> iterations/<span class="muRegEcx">ecx</span>: int <span class="Special">&lt;-</span> copy <span class="Constant">0</span>
<span id="L78" class="LineNr"> 78 </span>  <span class="Delimiter">{</span>
<span id="L79" class="LineNr"> 79 </span>    <span class="PreProc">var</span> done?/eax: boolean <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L94'>mandelbrot-done?</a> x, y
<span id="L80" class="LineNr"> 80 </span>    compare done?, <span class="Constant">0</span>/false
<span id="L81" class="LineNr"> 81 </span>    <span class="PreProc">break-if-!=</span>
<span id="L82" class="LineNr"> 82 </span>    compare iterations, max
<span id="L83" class="LineNr"> 83 </span>    <span class="PreProc">break-if-&gt;=</span>
<span id="L84" class="LineNr"> 84 </span>    <span class="PreProc">var</span> newx/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L112'>mandelbrot-x</a> x, y, real
<span id="L85" class="LineNr"> 85 </span>    <span class="PreProc">var</span> newy/<span class="Constant">xmm3</span>: float <span class="Special">&lt;-</span> <a href='mandelbrot.mu.html#L124'>mandelbrot-y</a> x, y, imaginary
<span id="L86" class="LineNr"> 86 </span>    x <span class="Special">&lt;-</span> copy newx
<span id="L87" class="LineNr"> 87 </span>    y <span class="Special">&lt;-</span> copy newy
<span id="L88" class="LineNr"> 88 </span>    iterations <span class="Special">&lt;-</span> increment
<span id="L89" class="LineNr"> 89 </span>    <span class="PreProc">loop</span>
<span id="L90" class="LineNr"> 90 </span>  <span class="Delimiter">}</span>
<span id="L91" class="LineNr"> 91 </span>  <span class="PreProc">return</span> iterations
<span id="L92" class="LineNr"> 92 </span><span class="Delimiter">}</span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L94'>mandelbrot-done?</a></span> x: float, y: float<span class="PreProc"> -&gt; </span>_/eax: boolean <span class="Delimiter">{</span>
<span id="L95" class="LineNr"> 95 </span>  <span class="muComment"># x*x + y*y &gt; 4</span>
<span id="L96" class="LineNr"> 96 </span>  <span class="PreProc">var</span> x2/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x
<span id="L97" class="LineNr"> 97 </span>  x2 <span class="Special">&lt;-</span> multiply x
<span id="L98" class="LineNr"> 98 </span>  <span class="PreProc">var</span> y2/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy y
<span id="L99" class="LineNr"> 99 </span>  y2 <span class="Special">&lt;-</span> multiply y
<span id="L100" class="LineNr">100 </span>  <span class="PreProc">var</span> sum/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x2
<span id="L101" class="LineNr">101 </span>  sum <span class="Special">&lt;-</span> add y2
<span id="L102" class="LineNr">102 </span>  <span class="PreProc">var</span> four/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">4</span>
<span id="L103" class="LineNr">103 </span>  <span class="PreProc">var</span> four-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert four
<span id="L104" class="LineNr">104 </span>  compare sum, four-f
<span id="L105" class="LineNr">105 </span>  <span class="Delimiter">{</span>
<span id="L106" class="LineNr">106 </span>    <span class="PreProc">break-if-float&gt;</span>
<span id="L107" class="LineNr">107 </span>    <span class="PreProc">return</span> <span class="Constant">0</span>/false
<span id="L108" class="LineNr">108 </span>  <span class="Delimiter">}</span>
<span id="L109" class="LineNr">109 </span>  <span class="PreProc">return</span> <span class="Constant">1</span>/true
<span id="L110" class="LineNr">110 </span><span class="Delimiter">}</span>
<span id="L111" class="LineNr">111 </span>
<span id="L112" class="LineNr">112 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L112'>mandelbrot-x</a></span> x: float, y: float, real: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm2</span>: float <span class="Delimiter">{</span>
<span id="L113" class="LineNr">113 </span>  <span class="muComment"># x*x - y*y + real</span>
<span id="L114" class="LineNr">114 </span>  <span class="PreProc">var</span> x2/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x
<span id="L115" class="LineNr">115 </span>  x2 <span class="Special">&lt;-</span> multiply x
<span id="L116" class="LineNr">116 </span>  <span class="PreProc">var</span> y2/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy y
<span id="L117" class="LineNr">117 </span>  y2 <span class="Special">&lt;-</span> multiply y
<span id="L118" class="LineNr">118 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> copy x2
<span id="L119" class="LineNr">119 </span>  result <span class="Special">&lt;-</span> subtract y2
<span id="L120" class="LineNr">120 </span>  result <span class="Special">&lt;-</span> add real
<span id="L121" class="LineNr">121 </span>  <span class="PreProc">return</span> result
<span id="L122" class="LineNr">122 </span><span class="Delimiter">}</span>
<span id="L123" class="LineNr">123 </span>
<span id="L124" class="LineNr">124 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L124'>mandelbrot-y</a></span> x: float, y: float, imaginary: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm3</span>: float <span class="Delimiter">{</span>
<span id="L125" class="LineNr">125 </span>  <span class="muComment"># 2*x*y + imaginary</span>
<span id="L126" class="LineNr">126 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L127" class="LineNr">127 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert two
<span id="L128" class="LineNr">128 </span>  result <span class="Special">&lt;-</span> multiply x
<span id="L129" class="LineNr">129 </span>  result <span class="Special">&lt;-</span> multiply y
<span id="L130" class="LineNr">130 </span>  result <span class="Special">&lt;-</span> add imaginary
<span id="L131" class="LineNr">131 </span>  <span class="PreProc">return</span> result
<span id="L132" class="LineNr">132 </span><span class="Delimiter">}</span>
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span><span class="muComment"># Scale (x, y) pixel coordinates to a complex plane where the viewport width</span>
<span id="L135" class="LineNr">135 </span><span class="muComment"># ranges from (scene-cx - scene-width/2) to (scene-cx + scene-width/2).</span>
<span id="L136" class="LineNr">136 </span><span class="muComment"># Viewport height just follows the viewport's aspect ratio.</span>
<span id="L137" class="LineNr">137 </span>
<span id="L138" class="LineNr">138 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L138'>viewport-to-real</a></span> x: int, width: int, scene-cx: float, scene-width: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm0</span>: float <span class="Delimiter">{</span>
<span id="L139" class="LineNr">139 </span>  <span class="muComment"># 0 in the viewport       goes to scene-cx - scene-width/2 </span>
<span id="L140" class="LineNr">140 </span>  <span class="muComment"># width in the viewport   goes to scene-cx + scene-width/2</span>
<span id="L141" class="LineNr">141 </span>  <span class="muComment"># Therefore:</span>
<span id="L142" class="LineNr">142 </span>  <span class="muComment"># x in the viewport       goes to (scene-cx - scene-width/2) + x*scene-width/width</span>
<span id="L143" class="LineNr">143 </span>  <span class="muComment"># At most two numbers being multiplied before a divide, so no risk of overflow.</span>
<span id="L144" class="LineNr">144 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert x
<span id="L145" class="LineNr">145 </span>  result <span class="Special">&lt;-</span> multiply scene-width
<span id="L146" class="LineNr">146 </span>  <span class="PreProc">var</span> width-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert width
<span id="L147" class="LineNr">147 </span>  result <span class="Special">&lt;-</span> divide width-f
<span id="L148" class="LineNr">148 </span>  result <span class="Special">&lt;-</span> add scene-cx
<span id="L149" class="LineNr">149 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L150" class="LineNr">150 </span>  <span class="PreProc">var</span> two-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert two
<span id="L151" class="LineNr">151 </span>  <span class="PreProc">var</span> half-scene-width/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy scene-width
<span id="L152" class="LineNr">152 </span>  half-scene-width <span class="Special">&lt;-</span> divide two-f
<span id="L153" class="LineNr">153 </span>  result <span class="Special">&lt;-</span> subtract half-scene-width
<span id="L154" class="LineNr">154 </span>  <span class="PreProc">return</span> result
<span id="L155" class="LineNr">155 </span><span class="Delimiter">}</span>
<span id="L156" class="LineNr">156 </span>
<span id="L157" class="LineNr">157 </span><span class="PreProc">fn</span> <span class="muFunction"><a href='mandelbrot.mu.html#L157'>viewport-to-imaginary</a></span> y: int, width: int, height: int, scene-cy: float, scene-width: float<span class="PreProc"> -&gt; </span>_/<span class="Constant">xmm1</span>: float <span class="Delimiter">{</span>
<span id="L158" class="LineNr">158 </span>  <span class="muComment"># 0 in the viewport       goes to scene-cy - scene-width/2*height/width</span>
<span id="L159" class="LineNr">159 </span>  <span class="muComment"># height in the viewport  goes to scene-cy + scene-width/2*height/width</span>
<span id="L160" class="LineNr">160 </span>  <span class="muComment"># Therefore:</span>
<span id="L161" class="LineNr">161 </span>  <span class="muComment"># y in the viewport       goes to (scene-cy - scene-width/2*height/width) + y*scene-width/width</span>
<span id="L162" class="LineNr">162 </span>  <span class="muComment"># At most two numbers being multiplied before a divide, so no risk of overflow.</span>
<span id="L163" class="LineNr">163 </span>  <span class="PreProc">var</span> result/<span class="Constant">xmm0</span>: float <span class="Special">&lt;-</span> convert y
<span id="L164" class="LineNr">164 </span>  result <span class="Special">&lt;-</span> multiply scene-width
<span id="L165" class="LineNr">165 </span>  <span class="PreProc">var</span> width-f/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> convert width
<span id="L166" class="LineNr">166 </span>  result <span class="Special">&lt;-</span> divide width-f
<span id="L167" class="LineNr">167 </span>  result <span class="Special">&lt;-</span> add scene-cy
<span id="L168" class="LineNr">168 </span>  <span class="PreProc">var</span> two/eax: int <span class="Special">&lt;-</span> copy <span class="Constant">2</span>
<span id="L169" class="LineNr">169 </span>  <span class="PreProc">var</span> two-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert two
<span id="L170" class="LineNr">170 </span>  <span class="PreProc">var</span> second-term/<span class="Constant">xmm1</span>: float <span class="Special">&lt;-</span> copy scene-width
<span id="L171" class="LineNr">171 </span>  second-term <span class="Special">&lt;-</span> divide two-f
<span id="L172" class="LineNr">172 </span>  <span class="PreProc">var</span> height-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert height
<span id="L173" class="LineNr">173 </span>  second-term <span class="Special">&lt;-</span> multiply height-f
<span id="L174" class="LineNr">174 </span>  <span class="PreProc">var</span> width-f/<span class="Constant">xmm2</span>: float <span class="Special">&lt;-</span> convert width
<span id="L175" class="LineNr">175 </span>  second-term <span class="Special">&lt;-</span> divide width-f
<span id="L176" class="LineNr">176 </span>  result <span class="Special">&lt;-</span> subtract second-term
<span id="L177" class="LineNr">177 </span>  <span class="PreProc">return</span> result
<span id="L178" class="LineNr">178 </span><span class="Delimiter">}</span>
</pre>
</body>
</html>
<!-- vim: set foldmethod=manual : -->
